import { world,system } from '@minecraft/server'

//Created by CausalGuide
//Created by CausalGuide
//Created by CausalGuide
system.runInterval(()=>{
	for(const player of world.getAllPlayers()){
		
		const dimension = player.dimension
		for(const seat of dimension.getEntities()){
			if(seat.typeId == "js:sit"){
				if(!seat.hasTag("anywhere")){
					const block = dimension.getBlock(seat.location)
					if(block.typeId.includes("slab") || block.typeId.includes("stair") || block.typeId.includes("carpet")){
						
					}else{
						const riding = seat.getComponent("minecraft:rideable")
						for(const rider of riding.getRiders()){
							riding.ejectRider(rider)
						}
					}
				}
			}
		}
	}
})
system.runInterval(()=>{
	for(const player of world.getAllPlayers()){
		player.runCommand("tp @e[r=1,c=1,type=js:sit] ~~~ facing ^^^2")
	}
},15)
//command prefix
var prefix = "+"

world.beforeEvents.chatSend.subscribe((eventData) => {
	const player = eventData.sender;
	if(eventData.message == `${prefix}sit`){
		
		eventData.cancel = true;
		system.runTimeout(()=>{
			player.runCommand('summon js:sit ~~0.7~ facing ^^^10');
			player.runCommand("tag @e[r=1,c=1,type=js:sit] add anywhere")
			player.runCommand("ride @s start_riding @e[r=1,c=1,type=js:sit] teleport_rider")
			system.runTimeout(()=>{
				player.runCommand("title @s actionbar §2Sneak/Jump to exit")
			},1)
		},4)
	}
});

world.afterEvents.playerInteractWithBlock.subscribe((eventData)=>{
	const player = eventData.player
	const block = eventData.block
	const x = Math.floor(block.location.x)
	const y = Math.floor(block.location.y)
	const z = Math.floor(block.location.z)
	if(!player.isSneaking && player.getComponent("minecraft:riding") == undefined && block.above().isAir){
		if(block.typeId.includes("stairs") && block.permutation.getState("upside_down_bit") == false){
			sit(player,x,y+0.7,z)
		}
		if(block.typeId.includes("carpet")){
			sit(player,x,y+0.4,z)
		}
		if(block.typeId.includes("slab") && block.permutation.getState("minecraft:vertical_half") == "top"){
			sit(player,x,y+0.9,z)
		}
		if(block.typeId.includes("slab") && block.permutation.getState("minecraft:vertical_half") == "bottom"){
			sit(player,x,y+0.6,z)
		}
	}
	if(!player.getComponent("minecraft:riding") == undefined){
		player.runCommand("tp @e[r=1,c=1,type=js:sit] ~~~ facing ^^^2")
	}
})

function sit(player,x,y,z,face){
	system.runTimeout(()=>{
		player.runCommand(`summon js:sit ${x} ${y} ${z} facing ^^^10`)
		player.runCommand(`ride @s start_riding @e[x=${x},y=${y},z=${z},c=1,type=js:sit] teleport_rider`)
		system.runTimeout(()=>{
			player.runCommand("title @s actionbar §2Sneak/Jump to exit")
		},1)
	},2)
}
//0=x-,1=x+,2=z-,3=,z+